# CSVHierarchyInput (ARX API Documentation)

org.deidentifier.arx.io

## Class CSVHierarchyInput

- java.lang.Object
- - org.deidentifier.arx.io.CSVHierarchyInput

-     public class CSVHierarchyInput
      extends java.lang.Object

  Reads a CSV encoded generalization hierarchy.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CSVHierarchyInput(java.io.File file, java.nio.charset.Charset charset)` Instantiate.
    `CSVHierarchyInput(java.io.File file, java.nio.charset.Charset charset, char delimiter)` Instantiate.
    `CSVHierarchyInput(java.io.File file, java.nio.charset.Charset charset, char delimiter, char quote)` Instantiate.
    `CSVHierarchyInput(java.io.File file, java.nio.charset.Charset charset, char delimiter, char quote, char escape)` Instantiate.
    `CSVHierarchyInput(java.io.File file, java.nio.charset.Charset charset, char delimiter, char quote, char escape, char[] linebreak)` Instantiate.
    `CSVHierarchyInput(java.io.File file, java.nio.charset.Charset charset, CSVSyntax config)` Instantiate.
    `CSVHierarchyInput(java.io.InputStream stream, java.nio.charset.Charset charset)` Instantiate.
    `CSVHierarchyInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter)` Instantiate.
    `CSVHierarchyInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter, char quote)` Instantiate.
    `CSVHierarchyInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter, char quote, char escape)` Instantiate.
    `CSVHierarchyInput(java.io.InputStream stream, java.nio.charset.Charset charset, char delimiter, char quote, char escape, char[] linebreak)` Instantiate.
    `CSVHierarchyInput(java.io.InputStream stream, java.nio.charset.Charset charset, CSVSyntax config)` Instantiate.
    `CSVHierarchyInput(java.lang.String filename, java.nio.charset.Charset charset)` Instantiate.
    `CSVHierarchyInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter)` Instantiate.
    `CSVHierarchyInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter, char quote)` Instantiate.
    `CSVHierarchyInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter, char quote, char escape)` Instantiate.
    `CSVHierarchyInput(java.lang.String filename, java.nio.charset.Charset charset, char delimiter, char quote, char escape, char[] linebreak)` Instantiate.
    `CSVHierarchyInput(java.lang.String filename, java.nio.charset.Charset charset, CSVSyntax config)` Instantiate.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String[][]` | `getHierarchy()` Returns the hierarchy.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.File file,
                           java.nio.charset.Charset charset)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.File file,
                           java.nio.charset.Charset charset,
                           char delimiter)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.File file,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
        `quote` - the quote
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.File file,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote,
                           char escape)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.File file,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote,
                           char escape,
                           char[] linebreak)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.File file,
                           java.nio.charset.Charset charset,
                           CSVSyntax config)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `file` - the file
        `config` - the config
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.InputStream stream,
                           java.nio.charset.Charset charset)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.InputStream stream,
                           java.nio.charset.Charset charset,
                           char delimiter)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.InputStream stream,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
        `quote` - the quote
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.InputStream stream,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote,
                           char escape)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.InputStream stream,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote,
                           char escape,
                           char[] linebreak)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.io.InputStream stream,
                           java.nio.charset.Charset charset,
                           CSVSyntax config)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `stream` - the stream
        `config` - the config
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.lang.String filename,
                           java.nio.charset.Charset charset)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.lang.String filename,
                           java.nio.charset.Charset charset,
                           char delimiter)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.lang.String filename,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
        `quote` - the quote
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.lang.String filename,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote,
                           char escape)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.lang.String filename,
                           java.nio.charset.Charset charset,
                           char delimiter,
                           char quote,
                           char escape,
                           char[] linebreak)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `delimiter` - the delimiter
        `quote` - the quote
        `escape` - the escape
        `linebreak` - the linebreak
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

    - #### CSVHierarchyInput

          public CSVHierarchyInput(java.lang.String filename,
                           java.nio.charset.Charset charset,
                           CSVSyntax config)
                            throws java.io.IOException

      Instantiate.
      Parameters:
        `filename` - the filename
        `config` - the config
      Throws:
        `java.io.IOException` - Signals that an I/O exception has occurred.

  - ### Method Detail

    - #### getHierarchy

          public java.lang.String[][] getHierarchy()

      Returns the hierarchy.
      Returns:
        the hierarchy